int cuda_init();
void cuda_check_err();
int get_arg(int, char**, int*, char**);
int read_coo_MM(struct coo_t *coo, char *matfile);
void COO2CSR(struct coo_t *, struct csr_t *);
void cudaMallocCSR(int n, int nnz, struct csr_t *d_csr);
void CSRHost2Device(struct csr_t *, struct csr_t *);
void cudaMallocLU(int n, int nnzl, int nnzu, struct lu_t *d_lu);
void LUHost2Device(struct lu_t *h_lu, struct lu_t *d_lu);
void FreeCOO(struct coo_t *coo);
void FreeCSR(struct csr_t *csr);
void FreeLU(struct lu_t *h_lu);
void FreeLev(struct level_t *h_lev);
void CudaFreeCSR(struct csr_t *d_csr);
void CudaFreeLU(struct lu_t *d_lu);
void CudaFreeLev(struct level_t *h_lev);
extern "C" void coocsr_(int *, int *, REAL *,
                        int *, int *, REAL *, int *, int *);
int ilu0(struct csr_t *csr, struct lu_t *lu);
void sortrow(int n, int *ia, int *ja, REAL *a);
void luSolv(int n, int nnz, struct lu_t *d_lu, REAL *d_x, REAL *d_b);
void makeLevel(struct lu_t *, struct level_t *, struct level_t *);
void luSolCPU(int n, int nnz, REAL *b, REAL *x, REAL *la, int *lja,
              int *lia, REAL *ua, int *uja, int *uia);
void luSolvLev(int n, int nnz, struct lu_t *d_lu, struct level_t*, 
               struct level_t *d_lev, REAL *d_x, REAL *d_b);
void csrcsc(int n, int n2, int job, int ipos, 
            REAL *a, int *ja, int *ia, 
	    REAL *ao, int *jao, int *iao);
void Reorder_MMD(struct csr_t *A, int **perm, int **iperm);
void RowColPermMat(struct csr_t *A, int *perm);
double wall_timer();
double error_norm(REAL *x, REAL *y, int n);
